
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Linux操作系统内存管理的源码实现 / iVAN</title>

    <meta name="description" content="Linux操作系统内存管理的源码实现 最近一段时间在阅读Linux的源代码,想把看到的东西写出来,觉得内存这一部分最简单,就先写了出 来.请指正! 内存最低4K的地址是一张页目录(page_dir),页目录共1024项,每项4字节.目录项的结构如下: ____________________________________ |32-12位为页框地址 | |U|R|p| | | |S|W| | |_________________|______ |_|_ |_| 随后的16K,用来做了4张页表,页表项结构和页目录项结构一样.页表的每一">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Linux操作系统内存管理的源码实现</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>最近一段时间在阅读Linux的源代码，想把看到的东西写出来，觉得内存这一部分最简单，就先写了出 来。请指正！</p>
<p>内存最低4K的地址是一张页目录(page_dir)，页目录共1024项，每项4字节。目录项的结构如下：</p>
<pre>
____________________________________
｜32-12位为页框地址　 ｜　　　　 ｜U｜R｜p｜
｜　　　　　　　　　　　　　　　　　　 ｜　　　　　　　 ｜S｜W｜ ｜
｜_________________｜______ ｜_｜_ ｜_｜</pre>
<p>随后的16K，用来做了4张页表，页表项结构和页目录项结构一样。页表的每一项指向一个物理页面,也 就是指向内存中的一个4K大小的空间。有了这4张页表，已经能寻址16M的内存了。下面就是在系统初始化 的时候在head.s程序中设置一张页目录和四张页表的代码。此时页目录中仅前4项有效，正是指向位于其 下面的4张页表，而这4张页表寻址了内存的最低16M。</p>
<pre>
198 setup_paging:
199　　　　 movl 24*5,%ecx　　　　　　　 /* 5 pages - pg_dir+4 page tables */
200　　　　 xorl %eax,%eax
201　　　　 xorl %edi,%edi　　　　　　　　　/* pg_dir is at 0x000 */
202　　　　 cld;rep;stosl
203　　　　 movl $pg0+7,_pg_dir　　　　　　 /* set present bit/user r/w */
204　　　　 movl $pg1+7,_pg_dir+4　　　　　 /*　--------- " " --------- */
205　　　　 movl $pg2+7,_pg_dir+8　　　　　 /*　--------- " " --------- */
206　　　　 movl $pg3+7,_pg_dir+12　　　　　/*　--------- " " --------- */
207　　　　 movl $pg3+4092,%edi
208　　　　 movl xfff007,%eax　　　　　　 /*　16Mb - 4096 + 7 (r/w user,p) */
209　　　　 std
210 1:　　　stosl　　　　　　　　　 /* fill pages backwards - more efficient :-) */
211　　　　 subl x1000,%eax
212　　　　 jge 1b</pre>
<p>以后每次有fork新进程，都要为新进程分配内存。但具体是怎么做的呢，我也想知道，一起看吧。当 执行fork时，它使用int0x80调用sys_fork函数，sys_fork的代码位于system_call.s中，很短如下：</p>
<pre>
208 _sys_fork:
209　　　　 call _find_empty_process
210　　　　 testl %eax,%eax
211　　　　 js 1f
212　　　　 push %gs
213　　　　 pushl %esi
214　　　　 pushl %edi
215　　　　 pushl %ebp
216　　　　 pushl %eax
217　　　　 call _copy_process
218　　　　 addl ,%esp
219 1:　　　ret</pre>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索目录<br />
                    ，                内存<br />
                                    指向<br />
                                    linux文件系统源码、linux操作系统源代码、linux系统源代码、linux系统源码、linux文件系统源代码，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 06:38:14</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e7%9b%ae%e5%bd%95/" title="目录">目录</a>, <a href="https://www.iamivan.net/tag/%e5%86%85%e5%ad%98/" title="内存">内存</a>, <a href="https://www.iamivan.net/tag/%e6%8c%87%e5%90%91/" title="指向">指向</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Linux操作系统内存管理的源码实现的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZd95OM.html" rel="bookmark">Linux堆内存管理深入分析（上）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux堆内存管理深入分析 (上半部) 作者:走位@阿里聚安全 0 前言 近年来,漏洞挖掘越来越火,各种漏洞挖掘.利用的分析文章层出不穷.从大方向来看,主要有基于栈溢出的漏洞利用和基于堆溢出的漏洞利用两种.国内关于栈溢出的资料相对较多,这里就不累述了,但是关于堆溢出的漏洞利用资料就很少了.鄙人以为主要是堆溢出漏洞的门槛较高,需要先吃透相应操作系统的堆内存管理机制,而这部分内容一直是一个难点.因此本系列文章主要从Linux系统堆内存管理机制出发,逐步介绍诸如基本堆溢出漏洞.基于unlink的堆溢			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAA5dKM.html" rel="bookmark">Linux堆内存管理深入分析&lpar;上&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				0 前言 近年来,漏洞挖掘越来越火,各种漏洞挖掘.利用的分析文章层出不穷.从大方向来看,主要有基于栈溢出的漏洞利用和基于堆溢出的漏洞利用两种.国内关于栈溢出的资料相对较多,这里就不累述了,但是关于堆溢出的漏洞利用资料就很少了.鄙人以为主要是堆溢出漏洞的门槛较高,需要先吃透相应操作系统的堆内存管理机制,而这部分内容一直是一个难点.因此本系列文章主要从Linux系统堆内存管理机制出发,逐步介绍诸如基本堆溢出漏洞.基于unlink的堆溢出漏洞利用.double free.use-after-free等			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba4ooJz.html" rel="bookmark">Linux堆内存管理深入分析 &lpar;上半部&rpar;【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://www.cnblogs.com/alisecurity/p/5486458.html 0 前言 近年来,漏洞挖掘越来越火,各种漏洞挖掘.利用的分析文章层出不穷.从大方向来看,主要有基于栈溢出的漏洞利用和基于堆溢出的漏洞利用两种.国内关于栈溢出的资料相对较多,这里就不累述了,但是关于堆溢出的漏洞利用资料就很少了.鄙人以为主要是堆溢出漏洞的门槛较高,需要先吃透相应操作系统的堆内存管理机制,而这部分内容一直是一个难点.因此本系列文章主要从Linux系统堆内存管理机制出发,逐步介绍诸			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB19Woz.html" rel="bookmark">Linux堆内存管理深入分析 &lpar;下&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux堆内存管理深入分析 (下半部)         作者:走位@阿里聚安全  0 前言回顾 在上一篇文章中,详细介绍了堆内存管理中涉及到的基本概念以及相互关系,同时也着重介绍了堆中chunk分配和释放策略中使用到的隐式链表技术.通过前面的介绍,我们知道使用隐式链表来管理内存chunk总会涉及到内存的遍历,效率极低.对此glibc malloc引入了显示链表技术来提高堆内存分配和释放的效率. 所谓的显示链表就是我们在数据结构中常用的链表,而链表本质上就是将一些属性相同的&quot;结点&quot;串联			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjjRwmb.html" rel="bookmark">Linux下USB suspend&sol;resume源码分析【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://blog.csdn.net/aaronychen/article/details/3928479 Linux下USB suspend/resume源码分析 Author:aaron   本文主要从自己开发的一个USB驱动的例子来深入讲解linux内核是如何支持USB设备的休眠和唤醒的, 最近我在为我们公司的一个模块写linux下的驱动, 其中之一就是要支持USB的休眠唤醒问题, 实际上linux内核对USB的这个功能的支持还是比较新的, 也就是最近几年的事.   一  打开/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze4da8p.html" rel="bookmark">浅谈Linux的内存管理机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一 物理内存和虚拟内存 我们知道,直接从物理内存读写数据要比从硬盘读写数据要快的多,因此,我们希望所有数据的读取和写入都在内存完成,而内存是有限的,这样就引出了物理内存与虚拟内存的概念. 物理内存就是系统硬件提供的内存大小,是真正的内存,相对于物理内存,在linux下还有一个虚拟内存的概念,虚拟内存就是为了满足物理内存的不足而提出的策略,它是利用磁盘空间虚拟出的一块逻辑内存,用作虚拟内存的磁盘空间被称为交换空间(Swap Space). 作为物理内存的扩展,linux会在物理内存不足时,使用交换			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNjqWNM.html" rel="bookmark">Linux编译内核，内核源码在哪里&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux编译内核,内核源码在哪里? 1.一般在发行版的盘里都有,比如 RedHat,一般在第二.第三张上 2.4 内核的叫 kernel-source-2.4.xx-xx.rpm2.6 内核的叫 kernel-devel-2.6.xx-xx.rpm 2.去www.kernel.org 下载一份你喜欢的内核版本,重新编译安装也可以.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mye28vM.html" rel="bookmark">C&num;共享内存实例 附源码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文 C#共享内存实例 附源码 网上有C#共享内存类,不过功能太简单了,并且写内存每次都从开头写.故对此进行了改进,并做了个小例子,供需要的人参考. 主要改进点: 通过利用共享内存的一部分空间(以下称为&quot;数据信息区&quot;)来存储当前内存中存储的数据信息(count和length或者添加其他信息),完成了对内存读写功能的完善. 在读写内存时,读写数据信息区. 1.写共享内存 根据共享内存当前的使用length,依次往后写. 2.读共享内存 读取从共享内存的起始位置(不包括数据信息区)至len			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWNVgjb.html" rel="bookmark">Linux中如何安装内核源码包&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux中如何安装内核源码包? 有些时候,我们需要对系统的内核进行升级操作,我们可以使用rpm命令来完成. 下载新的iso光盘镜像文件,并挂载iso文件到光盘. 把你光盘上的内核源码包装上即可,我们使用如下命令: rpm -i *kernel*source*.rpm			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJ9VJp.html" rel="bookmark" class="title">用VisualC&num;编写仿MSNMessager的滚动提示窗口</a>
					<div>
						visual 目录引言 实现方法 作者简介 ------------------------------------------------------------------------------ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBEZaz.html" rel="bookmark" class="title">浅谈友情链接要点之二：相关性不可忽视</a>
					<div>
						前端时间写了一份友情链接要点之一:内页不可忽视,那么今天就接着写第二,那就是友情链接中我们经常提到的相关性,相关性是啥,相关性就是你家卖苹果,他家卖红苹果,另外一家卖青苹果,完全就是一个苹果世家,你们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9Z9Vp.html" rel="bookmark" class="title">浅谈降权新站的排名如何&OpenCurlyDoubleQuote;重获新生&rdquo;</a>
					<div>
						不知大家有没有发现,当一个网站的被降权了,如果我们的优化力度多大,内容更新得再多,外链做得再好,排名还是原封不动呢?昨天我发布了&lt;热门关键词优化无效,排名不起色的原因&gt;这篇文章中提到我接了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNZONM.html" rel="bookmark" class="title">Informix管理：保护IDS数据</a>
					<div>
						前言 保护数据需要权衡考虑安全性和访问能力.如何找到最合适的方法呢? 目前,公司和政府为数据的可审计性和控制制定了严格的标准,这使数据库安全性成为近来的热点.DBA 必须保证用户能够访问完成工作所需的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNZXNM.html" rel="bookmark" class="title">fdisk命令使用详解</a>
					<div>
						FDISK并不象有些初级朋友想象的那么复杂,对!他是英文的,而且在DOS下不好用翻译软件,呵呵!其实我的英语水平也就是no,yes, good,ok,三块肉--记得在论坛有位朋友想给硬盘分区格式化,而 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7K43b.html" rel="bookmark" class="title">Windows 7通用快捷键及瘦身优化攻略</a>
					<div>
						Windows 7系统正在被更多的个人和企业用户所认识,也不断在有爱好者测试应用者探索他的功能.由于系统较新,其中的一些一些功能和优化设置还不被广大用户所发现,在此我为Windows 7的初步使用者, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxonKb.html" rel="bookmark" class="title">驯服Tiger&colon; 格式化输出</a>
					<div>
						J2SE 1.4 版原来的计划是包括对格式化输出的支持.可能由于时间限制及这个功能对新版本的发布不起决定作用的缘故,在发表的版本中没有加入这些功能.现在有了 Tiger,对打印带格式的字符串有了内在支 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7kP35z.html" rel="bookmark" class="title">路由器死机原因深入分析</a>
					<div>
						路由器死机原因一.带机数量引起的路由器死机 很多厂商在宣传自己的宽带路由器产品时一般都会提到一个可以连接的带机数量,大部分厂商都会说自己的四口宽带路由器可以带机10-20台.可是有些用户在使用过程中, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNO5oM.html" rel="bookmark" class="title">巧用DOS命令清除电脑公司win7系统中的CMOS密码的方法</a>
					<div>
						  具体步骤如下: 1.在DOS中有为大家提供了一个编辑器,就是DEBUG,这是一个非常实用的工具,具体启动方法是:在DOS命令提示符状态下输入命令:DEBUG,然后回车,此时即可进入DEBUG编辑界 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8jBZp.html" rel="bookmark" class="title">安装gr&lowbar;ieee802&period;11</a>
					<div>
						1.安装配置好gnuradio 2.安装log4cpp:sudo apt-get install liblog4cpp5-dev 3.安装IT++库:sudo apt-get install libi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlB7QVz.html" rel="bookmark" class="title">请问jdk源码该如何研究</a>
					<div>
						问题描述 请问jdk源码该如何研究 各位大神,小弟最近想看看jdk源码,想看看里面各个功能是怎么实现的,源码在myeclipse里面可以看到,但是不知道该如何开始,应该从哪里开始,希望各位大神指点迷津 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3LOWp.html" rel="bookmark" class="title">《破茧成蝶&mdash;&mdash;用户体验设计师的成长之路》一1&period;3&emsp;用户体验设计的特征</a>
					<div>
						1.3 用户体验设计的特征 破茧成蝶--用户体验设计师的成长之路 从前面的案例中,我们可以总结出如下用户体验设计的一些特征. 严谨.理性.创意 用户体验设计充满了理性和严谨,因为它首先关注于解决用户的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRqGdz.html" rel="bookmark" class="title">android-写入文件然后读取，然后再像一个字符串一样保存内容</a>
					<div>
						问题描述 写入文件然后读取,然后再像一个字符串一样保存内容 我想写进一个文件,然后,我想把内容保存在一个 StringBuffer 里面.最后再通过一个 TextView显示,但是什么也不显示. pu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lBAxb.html" rel="bookmark" class="title">iOS中线程Call Stack的捕获和解析（二）</a>
					<div>
						上接iOS中线程Call Stack的捕获和解析(一). 1. 部分参考资料 做这一块时也是查阅了很多链接和书籍,包括但不限于: &lt;OS X ABI Mach-O File Format Ref ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NWGYM.html" rel="bookmark" class="title">PostgreSQL服务器管理：服务器设置和操作</a>
					<div>
						本文档为PostgreSQL 9.6.0文档,本转载已得到原译者彭煜玮授权. 1. PostgreSQL用户账户 和对外部世界可访问的任何服务器守护进程一样,我们也建议在一个独立的用户账户下运行Pos ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOlYv3b.html" rel="bookmark" class="title">java-大神们，我自己想写个 彩票生成器，但是这串代码生成的数字会存在&OpenCurlyQuote;0&rsquo;请问下 是哪边有问题？</a>
					<div>
						问题描述 大神们,我自己想写个 彩票生成器,但是这串代码生成的数字会存在'0'请问下 是哪边有问题? public class Lottery { public static void main (S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Pvqvp.html" rel="bookmark" class="title">虚拟主机-云服务如果刮掉如何与本地服务器无缝切换？</a>
					<div>
						问题描述 云服务如果刮掉如何与本地服务器无缝切换? 我在Azure做虚拟主机部署网站,如果他挂掉了,如何与我本地服务器做到最快速的无缝切换? 解决方案 如果你使用2个实例的Azure虚拟机,它的可用性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjnWZp.html" rel="bookmark" class="title">Activity切换动画--模糊、水波纹、折叠效果 &period;&period;&period;</a>
					<div>
						Enhance Activity switch animation. source code : https://github.com/dkmeteor/ActivityAnimationLib 这是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYoAPp.html" rel="bookmark" class="title">asp&period;net跳转页面的三种方法比较（转）</a>
					<div>
						1. response.redirect 这个跳转页面的方法跳转的速度不快,因为它要走2个来回(2次postback),但他可以跳转到任何页面,没有站点页面限制(即可以由雅虎跳到新浪),同时不能跳过登 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boK3l3b.html" rel="bookmark" class="title">iOS发送的消息给我自己写的view给遮住了。。怎么办怎么办。。。。</a>
					<div>
						问题描述 我自己写了一个view用来导航条..那么问题就出现了..信息给遮挡住了一半..怎么办??我找了很多的办法..都没有用..求各位大神显灵啊...我是自己写的view来的..而不是demo自带的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXEl6z.html" rel="bookmark" class="title">点击电容触摸屏，VS崩溃，是什么原因？</a>
					<div>
						问题描述 我的电脑接了一个显示器,通过VGA转接头接了一个电容屏.打开VS,用手指触摸电容屏的时候,VS就崩溃了.异常信息如下:StackTrace信息:在System.Windows.Input.S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwv20M.html" rel="bookmark" class="title">多线程-QMetaObject&colon;&colon;invokeMethod 返回true&comma;但是对应的slot函数没有执行</a>
					<div>
						问题描述 QMetaObject::invokeMethod 返回true,但是对应的slot函数没有执行 先上代码: QMetaObject::invokeMethod(m_manager, &qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgDx4M.html" rel="bookmark" class="title">exception-对于URLClassLoader，Eclipse执行正确，而命令行执行抛出异常</a>
					<div>
						问题描述 对于URLClassLoader,Eclipse执行正确,而命令行执行抛出异常 [0]问题描述 0.1)晚辈我想利用URLClassLoader 加载某目录下的class文件,执行结果发现, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mye7oEM.html" rel="bookmark" class="title">浪潮HF系列闪存存储：不仅看性能，更看整体表现</a>
					<div>
						  背景:浪潮HF系列闪存存储是IT融合架构的基础,可支持核心数据库业务应用.服务器和桌面虚拟化架构.消息协同环境,并适应Microsoft.VMware.Citrix.Oracle.SAP.CISC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyW1dZz.html" rel="bookmark" class="title">jQuery实现的一个自定义Placeholder属性插件&lowbar;jquery</a>
					<div>
						HTML5中文本框的新属性placeholder是个非常好用的属性,但是IE系列直至IE9都不支持这一属性,这就让大家在用这一属性的时候有些犹豫不决.自己曾经写过很多类似共的小控件,但是都不是很通用, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrLe6p.html" rel="bookmark" class="title">jQuery制作简洁的图片轮播效果&lowbar;jquery</a>
					<div>
						演示图: 核心代码: $(document).ready(function(){ var $iBox = $('.imgBox'), $iNum = $('.imgNum'), //缓存优化 inde ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKQGWM.html" rel="bookmark" class="title">JavaScript学习笔记之数组求和方法&lowbar;javascript技巧</a>
					<div>
						推荐阅读:JavaScript学习笔记之数组的增.删.改.查 通过最近学习,越来越感觉JavaScript的强大与魅力之处,仅数组一个知识点就让我这样的初学者折腾了很久.折腾是折腾,但还是很有效果的, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOEdVb.html" rel="bookmark" class="title">网站优化注意事情与站长经验</a>
					<div>
						1) 欺骗搜索引擎教程 今天的搜索引擎是非常聪明,可以记录在其数据库教程中的信息.使用诸如屏蔽和混浊的技术可能导致网站被搜索引擎和网页禁止将不准在随后的搜查行动 2) 复杂的文章 并不是所有的观众都是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvwoyM.html" rel="bookmark" class="title">asp发送邮件代码</a>
					<div>
						function SendMail(MailServerAddress,AddRecipient,Subject,Body,Sender,MailFrom)  on error resume next ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYNn9b.html" rel="bookmark" class="title">百度i贴吧推广日IP过千淘宝客收入过千经验分享</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 大家好,我是淘侠客,今天给大家带来 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.038 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
